// JavaScript Document
(function(doc, win) {
	var docEl = doc.documentElement,
		resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize',
		recalc = function() {
			var clientWidth = docEl.clientWidth;
			if (!clientWidth) return;
			docEl.style.fontSize = 100 * (clientWidth / 750) + 'px';
		};

	if (!doc.addEventListener) return;
	win.addEventListener(resizeEvt, recalc, false);
	doc.addEventListener('DOMContentLoaded', recalc, false);
})(document, window);
//全局加载
$(window).load(function() {
	$("#status").fadeOut();
	$("#preloader").delay(300).fadeOut("slow");
})
var localStorage = window.localStorage;
var sessionStorage = window.sessionStorage;
/**
 * 设置session缓存
 * @param key
 * @param val
 */

function setSessionStorage(key, val) {
	sessionStorage.setItem(key, val);
}
/**
 * 获取session缓存
 * @param key
 */

function getSessionStorage(key) {
	return sessionStorage.getItem(key);
}
/**
 * 移除session缓存
 * @param key
 */

function removeSessionStorage(key) {
	sessionStorage.removeItem(key);
}
/**
 * 设置cookie
 */
function setCookie(name, value, exp){
	if(!exp){
		 var expdate1 = new Date();
		 //默认一天
         expdate1.setTime(expdate1.getTime() + 24 * 60 * 60 * 1000);
         exp=expdate1;
	}
	document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString();
}
/**
 * 获取cookie
 * @param key
 */
function getCookie(name){
	var arr = document.cookie.match(new RegExp("(^| )"+name+"=([^;]*)(;|$)"));
    if(arr != null) return unescape(arr[2]); return null;
}
//全局变量
var global={
		//API链接地址
			//正式接口
			API_URL:"http://api.yunhulu.org/",
			//测试接口
			//API_URL:"http://test.yunhulu.org/",
			//本地接口
			//API_URL:"http://127.0.0.1:8080/api_server/",
		//图片引用地址
		IMG01_URL:'http://yunhulu.b0.upaiyun.com/uploads/',
		//WEB项目路径地址
		WEB_URL:'http://www.yunhulu.org/'
}
//生成系统id

function uuid() {
	var s = [];
	var hexDigits = "0123456789abcdef";
	for (var i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = "-";

	var uuid = s.join("");
	return uuid;
}
/**
 * 判断是否为空
 */

function isBlank(obj) {
	if (obj == null || obj == "") {
		return true;
	}
	return false;
}
/**
 * 判断是否含有空格
 */

function check_space(str) {
	var re = /^\s+$/;
	if (re.exec(str)) {
		return true;
	}
	return false;
}
/**
 * 正整数判断
 */

function isPositiveInteger(obj) {
	var pattern = /^[0-9]*[1-9][0-9]*$/;
	return pattern.test(obj);
}

/**
 * 整数判断
 */

function isInteger(obj) {
	var pattern = /^-?\d+$/;
	return pattern.test(obj);
}

/**
 * 正浮点数判断
 */

function isPositiveFloat(obj) {
	var pattern = /^(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*))$/;
	return pattern.test(obj);
}
/**
 * 浮点数判断
 */

function isFloat(obj) {
	var pattern = /^([-]){0,1}([0-9]){1,}([.]){0,1}([0-9]){0,}$/;
	return pattern.test(obj);
}
/**
 * 手机号码判断
 */

function isMobilePhone(obj) {
	var pattern = /^(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/;
	return pattern.test(obj);
}
/**
 * 邮箱校验
 */

function isEmail(obj){
	var pattern = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
	return pattern.test(obj);
}
/**
 * 弹出错误信息提示框
 * @param msg
 */

function showErrorMsg(msg) {
	$().toastmessage('showToast', {
		text: msg,
		sticky: false,
		position: 'top-center',
		type: 'error',
		stayTime: 500,
		closeText: '',
		close: function() {

		}
	});
}
/**
 * 弹出提醒提示框
 * @param msg
 */

function showInfoMsg(msg) {
	$().toastmessage('showToast', {
		text: msg,
		sticky: false,
		position: 'top-center',
		type: 'notice',
		stayTime: 500,
		closeText: '',
		close: function() {}
	});
}
/**
 * 弹出警告提示框
 * @param msg
 */

function showWarnMsg(msg) {
	$().toastmessage('showToast', {
		text: msg,
		sticky: false,
		position: 'top-center',
		type: 'warning',
		stayTime: 500,
		closeText: '',
		close: function() {}
	});
}
/**
 * 弹出成功提示框
 * @param msg
 */

function showSuccessMsg(msg) {
	$().toastmessage('showToast', {
		text: msg,
		sticky: false,
		position: 'top-center',
		type: 'success',
		stayTime: 500,
		closeText: '',
		close: function() {}
	});
}


/**
 * 设置本地缓存
 */

function setLocalStorage(key, val) {
	localStorage.setItem(key, val);
}
/**
 * 获取本地缓存
 * @param key
 */

function getLocalStorage(key) {
	return localStorage.getItem(key);
}
/**
 * 移除本地缓存
 * @param key
 */

function removeLocalStorage(key) {
	localStorage.removeItem(key);
}

/**
 * 自动登录
 */

function autoLogin() {
	var username = getLocalStorage("USERNAME");
	var password = getLocalStorage("PASSWORD");
	var loginState = getSessionStorage("LOGIN_STATE");
	if (!isBlank(username) && !isBlank(username) && loginState != "1" && loginState != "2") {
		$.ajax({
			type: "get",
			url: global.API_URL + "consumer/login",
			dataType: "jsonp",
			sync: true,
			data: {
				consumername: username,
				password: password
			},
			timeout: 10000,
			success: function(data) {
				if (data.succ) {
					setSessionStorage("TOKEN", data.data);
					setLocalStorage("USERNAME", username);
					setLocalStorage("PASSWORD", password);
					setSessionStorage("LOGIN_STATE", "1");
					window.location.href = "index.html";
				} else {
					setSessionStorage("LOGIN_STATE", "2");
				}

			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				showErrorMsg("请求异常");
			}
		});
	}
}
$(function() {
	autoLogin();
});

function checkLogin() {
	return getSessionStorage("LOGIN_STATE") == "1";
}
String.prototype.startWith = function(compareStr) {
	return this.indexOf(compareStr) == 0;
}
Date.prototype.pattern = function(fmt) {
	var o = {
		"M+": this.getMonth() + 1,
		//月份           
		"d+": this.getDate(),
		//日           
		"h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12,
		//小时           
		"H+": this.getHours(),
		//小时           
		"m+": this.getMinutes(),
		//分           
		"s+": this.getSeconds(),
		//秒           
		"q+": Math.floor((this.getMonth() + 3) / 3),
		//季度           
		"S": this.getMilliseconds() //毫秒           
	};
	var week = {
		"0": "/u65e5",
		"1": "/u4e00",
		"2": "/u4e8c",
		"3": "/u4e09",
		"4": "/u56db",
		"5": "/u4e94",
		"6": "/u516d"
	};
	if (/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	if (/(E+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "/u661f/u671f" : "/u5468") : "") + week[this.getDay() + ""]);
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
}
/**
 * 获取参数
 */

function getUrlParam(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
	var r = window.location.search.substr(1).match(reg); //匹配目标参数
	if (r != null) return unescape(r[2]);
	return null; //返回参数值
}


/*jQuery(document).ready(function($) {
	$('#full-width-slider').royalSlider({
		arrowsNav: true,
		loop: false,
		keyboardNavEnabled: true,
		controlsInside: false,
		imageScaleMode: 'fill',
		arrowsNavAutoHide: false,
		autoScaleSlider: true,
		autoScaleSliderWidth: 960,
		autoScaleSliderHeight: 850,
		controlNavigation: 'bullets',
		thumbsFitInViewport: false,
		navigateByClick: true,
		startSlideId: 0,
		autoPlay: false,
		transitionType: 'move',
		globalCaption: true,
		deeplinking: {
			enabled: true,
			change: false
		},
		
	});
});

$(document).ready(function() {
	$('.inactive').click(function() {
		if ($(this).siblings('ul').css('display') == 'none') {
			$(this).parent('li').siblings('li').removeClass('inactives');
			$(this).addClass('inactives');
			$(this).siblings('ul').slideDown(100).children('li');
			if ($(this).parents('li').siblings('li').children('ul').css('display') == 'block') {
				$(this).parents('li').siblings('li').children('ul').parent('li').children('a').removeClass('inactives');
				$(this).parents('li').siblings('li').children('ul').slideUp(100);

			}
		} else {
			//控制自身变成+号
			$(this).removeClass('inactives');
			//控制自身菜单下子菜单隐藏
			$(this).siblings('ul').slideUp(100);
			//控制自身子菜单变成+号
			$(this).siblings('ul').children('li').children('ul').parent('li').children('a').addClass('inactives');
			//控制自身菜单下子菜单隐藏
			$(this).siblings('ul').children('li').children('ul').slideUp(100);

			//控制同级菜单只保持一个是展开的（-号显示）
			$(this).siblings('ul').children('li').children('a').removeClass('inactives');
		}
	})
});
*/

function syncStatus(status) {
	switch (status) {
	case SyncStatus.DOWNLOADING_PACKAGE:
		// Show "downloading" modal
		$("#update").show();
		break;
	case SyncStatus.INSTALLING_UPDATE:
		//codePush.restartApplication();
		// Hide "downloading" modal
		$("#update").hide();
		break;
	}
}

function downloadProgress(totalBytes, receivedBytes) {
	var percent=receivedBytes/totalBytes*100;
	// Update "downloading" modal with current download %
	$("#id_update").attr("style","width:"+percent+"%");
	if(totalBytes===receivedBytes){
		showInfoMsg("更新成功，等待重启！");
	}
}

function syncStatus(status) {
	switch (status) {
	case SyncStatus.DOWNLOADING_PACKAGE:
		// Show "downloading" modal
		$(".container").show();
		$("#update").show();
		break;
	case SyncStatus.INSTALLING_UPDATE:
		//codePush.restartApplication();
		// Hide "downloading" modal
		$(".container").hide();
		$("#update").hide();
		break;
	}
}

function downloadProgress(totalBytes, receivedBytes) {
	
}

